apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "lorry2.fullname" . }}-controller
  labels:
    {{- include "lorry2.labels" . | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      {{- include "lorry2.controller.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      annotations:
        # will restart the deployment if config changes
        checksum/config: {{ include (print $.Template.BasePath "/configmap-controller.yaml") . | sha256sum }}
        {{- with .Values.podAnnotations }}
        {{- toYaml . | nindent 8 }}
        {{- end }}
      labels:
        {{- include "lorry2.controller.selectorLabels" . | nindent 8 }}
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "lorry2.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}-controller
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          env:
            - name: LORRY_MODE
              value: controller
            - name: TRACE
              value: "1"
            - name: DEBUG
              value: "1"
          ports:
            - name: http
              containerPort: {{ .Values.service.port }}
              protocol: TCP
          livenessProbe:
            httpGet:
              path: /1.0/health-check
              port: http
          readinessProbe:
            httpGet:
              path: /1.0/health-check
              port: http
          startupProbe:
            httpGet:
              path: /1.0/health-check
              port: http
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
          volumeMounts:
            - name: config-controller
              mountPath: /config
            - name: controller-volume
              mountPath: /db
      volumes:
        - name: config-controller
          configMap:
            name: {{ include "lorry2.fullname" . }}-controller
        - name: controller-volume
          persistentVolumeClaim:
            claimName: controller-pv-claim
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
